<template>
  <div
    tabindex="0"
    :class="[
      'select-item',
      selected && 'select-item--selected',
      isDropdown ? 'select-item--dropdown' : '',
      item.disabled && 'select-item--disabled'
    ]"
  >
    <button
      type="button"
      class="ob-selector__list-item"
      :class="{ 'ob-selector__list-item_active': selected, 'ob-selector__list-item_two-rows': twoRows }"
      :data-qa="dataQa"
      @click="isGroup ? toggleGroup(item) : setItem(item)"
    >
      <div class="ob-selector__list-item-title-wrapper">
        <div
          v-if="isGroup"
          class="ob-selector__controls"
        >
          <i
            v-if="hasChildren"
            :class="groupHeaderChevronClass"
          />
        </div>
        <ob-checkbox
          v-if="isDropdown"
          label=""
          :value="isParticularSelectedCheckbox"
          :type="checkboxType"
          class="ob-selector__list-item-checkbox"
          @change="isGroup ? selectGroup() : setItem(item)"
          @click.native.stop
        />
        <div
          v-if="item.icon"
          class="icon ob-selector__list-item-icon"
          :class="item.icon"
        />
        <div
          v-if="item.html"
          class="icon ob-selector__list-item-html"
          v-html="item.html"
        />
        <div :class="{'ob-selector__list-item-text': true, 'ob-selector__list-item-header-text': isGroup}">
          <span
            v-if="isSearch"
            v-html="item.searchResult"
          />
          <template v-else>
            {{ item[displayExp] }}
          </template>
        </div>
        <span
          v-if="isGroup && hasChildren && showGroupCount"
          class="ob-selector__list-item-header-count"
        >
          {{ item.children.length }}
        </span>
      </div>
      <div
        v-if="!isDropdown && isGroup && (!item.hideSelectButton || hasChildren)"
        class="select-item__header-button-outer"
        @click.stop
      >
        <ob-button
          label="Выбрать"
          mini
          type="flat"
          @click="isGroup ? selectGroup() : setItem(item)"
        />
      </div>
      <div
        v-if="item[subTitleExp]"
        :class="{'ob-selector__list-item-subtitle':true, 'ob-selector__list-item-subtitle-icon-shift': twoRows && item.icon}"
      >
        {{ item[subTitleExp] }}
      </div>
    </button>
  </div>
</template>
<script>
import ObCheckbox from '../obCheckbox'
import obButton from '../obButton'
export default {
  components: {
    ObCheckbox,
    obButton
  },
  props: {
    item: {
      type: Object,
      default: () => {}
    },
    displayExp: {
      type: String,
      default: 'title'
    },
    valueExp: {
      type: String,
      default: 'uuid'
    },
    subTitleExp: {
      type: String,
      default: 'subtitle'
    },
    selectedValue: {
      type: [Array, Object, String],
      default: () => []
    },
    isSearch: {
      type: Boolean,
      default: false
    },
    twoRows: {
      type: Boolean,
      default: false
    },
    useGroups: {
      type: Boolean,
      default: false
    },
    showGroupCount: {
      type: Boolean,
      default: false
    },
    isDropdown: {
      type: Boolean,
      default: false
    },
    dataQa: {
      type: String
    }
  },
  computed: {
    selected () {
      if (this.isDropdown) return false
      if (typeof this.selectedValue === 'string') {
        return this.selectedValue === this.item[this.valueExp]
      }
      return this.isDropdown
        ? this.isGroup ? this.isSelectedCheckbox : this.selectedValue.find((i) => i[this.valueExp] === this.item[this.valueExp])
        : this.isGroup ? this.item.children?.some((item) => this.selectedValue[this.valueExp] === item[this.valueExp]) : this.selectedValue[this.valueExp] === this.item[this.valueExp]
    },
    isGroup () {
      return this.item.children
    },
    hasChildren () {
      return this.item.children && this.item.children.length > 0
    },
    groupHeaderChevronClass () {
      return {
        'icon': true,
        'chevron-down': !this.item.isOpenedGroup,
        'chevron-up': this.item.isOpenedGroup
      }
    },
    isSelectedCheckbox () {
      if (!this.isDropdown) return false

      if (this.isGroup) {
        return this.item.children?.every((child) => this.selectedValue.find(item => item[this.valueExp] === child[this.valueExp]))
      } else {
        return this.selectedValue?.some((val) => val[this.valueExp] === this.item[this.valueExp])
      }
    },
    checkboxType () {
      if (!this.isGroup || !this.isDropdown) return 'default'

      const isExistValue = this.item.children?.some((item) => this.selectedValue.some((val) => val[this.valueExp] === item[this.valueExp]))
      const isNotAllSelected = !this.item.children?.every((item) => this.selectedValue.some((val) => val[this.valueExp] === item[this.valueExp]))

      return isExistValue && isNotAllSelected ? 'particular' : 'default'
    },
    isParticular () {
      return this.checkboxType === 'particular'
    },
    isParticularSelectedCheckbox () {
      return this.isSelectedCheckbox || this.isParticular
    }
  },
  methods: {
    setItem () {
      if (this.item.disabled) {
        return false
      }

      this.$emit('click', this.item)
    },
    selectGroup () {
      if (this.item.disabled) {
        return false
      }

      this.$emit('select-group', !this.isParticularSelectedCheckbox)
    },
    toggleGroup () {
      if (this.item.disabled) {
        return false
      }
      this.$emit('toggleGroup', this.item)
    }
  }
}
</script>

<style lang="scss" scoped>
.select-item {
  display: flex;
  align-items: center;

  button {
    padding: 8px var(--ob-selector-padding);
    .ob-selector__list-items-children & {
      padding: 7px var(--ob-selector-padding);
    }
  }

  &--dropdown {
    button {
      .ob-selector__list-items-children & {
        padding: 4px var(--ob-selector-padding);
      }
    }
  }

  &:hover,
  &:focus {
    background-color: $blue-150;
    outline: none;
  }

  &--selected {
    background-color: $blue-250;
  }

  &--disabled {
    cursor: not-allowed;
    background-color: $color-light-grey;

    &:hover {
      background-color: $color-light-grey;
    }

    button {
      pointer-events: none;
    }
  }

  &--dropdown {
    .ob-selector__list-item {
      //margin-left: 5px;
      &-checkbox {
        margin-right: 8px;
      }
    }
  }

  &__header-button-outer {
    align-self: center;
    margin: -8px 0;
  }
}
</style>
